int dyngen_code(uint8_t *gen_code_buf,
                uint16_t *label_offsets, uint16_t *jmp_offsets,
                const uint16_t *opc_buf, const uint32_t *opparam_buf, const long *gen_labels)
{
    uint8_t *gen_code_ptr;
    const uint16_t *opc_ptr;
    const uint32_t *opparam_ptr;

    gen_code_ptr = gen_code_buf;
    opc_ptr = opc_buf;
    opparam_ptr = opparam_buf;
    for(;;) {
        switch(*opc_ptr++) {
case INDEX_op_mov32: {
    long param1, param2;
    extern void op_mov32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_mov32+0), 24);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 20) = (long)(&helper_set_op) - (long)(gen_code_ptr + 20) + -4;
    gen_code_ptr += 24;
}
break;

case INDEX_op_mov32_im: {
    long param1, param2;
    extern void op_mov32_im();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_mov32_im+0), 17);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = param1 - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = (long)(&helper_set_op) - (long)(gen_code_ptr + 13) + -4;
    gen_code_ptr += 17;
}
break;

case INDEX_op_movf64: {
    long param1, param2;
    extern void op_movf64();
extern char helper_get_opf64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_movf64+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_zerof64: {
    long param1;
    extern void op_zerof64();
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_zerof64+0), 13);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 9) + -4;
    gen_code_ptr += 13;
}
break;

case INDEX_op_add32: {
    long param1, param2, param3;
    extern void op_add32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_add32+0), 44);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 29) = param1 - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 38) = (long)(&helper_set_op) - (long)(gen_code_ptr + 38) + -4;
    gen_code_ptr += 44;
}
break;

case INDEX_op_sub32: {
    long param1, param2, param3;
    extern void op_sub32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_sub32+0), 46);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 29) = param1 - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_op) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 46;
}
break;

case INDEX_op_mul32: {
    long param1, param2, param3;
    extern void op_mul32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_mul32+0), 47);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 33) = param1 - (long)(gen_code_ptr + 33) + -4;
    *(uint32_t *)(gen_code_ptr + 41) = (long)(&helper_set_op) - (long)(gen_code_ptr + 41) + -4;
    gen_code_ptr += 47;
}
break;

case INDEX_op_not32: {
    long param1, param2;
    extern void op_not32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_not32+0), 26);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_set_op) - (long)(gen_code_ptr + 22) + -4;
    gen_code_ptr += 26;
}
break;

case INDEX_op_neg32: {
    long param1, param2;
    extern void op_neg32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_neg32+0), 26);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_set_op) - (long)(gen_code_ptr + 22) + -4;
    gen_code_ptr += 26;
}
break;

case INDEX_op_bswap32: {
    long param1, param2;
    extern void op_bswap32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_bswap32+0), 57);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 17) = param1 - (long)(gen_code_ptr + 17) + -4;
    *(uint32_t *)(gen_code_ptr + 53) = (long)(&helper_set_op) - (long)(gen_code_ptr + 53) + -4;
    gen_code_ptr += 57;
}
break;

case INDEX_op_btest: {
    long param1, param2;
    extern void op_btest();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_btest+0), 44);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param1 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param2 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 44;
}
break;

case INDEX_op_addx_cc: {
    long param1, param2;
    extern void op_addx_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_addx_cc+0), 100);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param1 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param2 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 89) = param1 - (long)(gen_code_ptr + 89) + -4;
    *(uint32_t *)(gen_code_ptr + 94) = (long)(&helper_set_op) - (long)(gen_code_ptr + 94) + -4;
    gen_code_ptr += 100;
}
break;

case INDEX_op_subx_cc: {
    long param1, param2;
    extern void op_subx_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_subx_cc+0), 99);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param1 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param2 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 88) = param1 - (long)(gen_code_ptr + 88) + -4;
    *(uint32_t *)(gen_code_ptr + 93) = (long)(&helper_set_op) - (long)(gen_code_ptr + 93) + -4;
    gen_code_ptr += 99;
}
break;

case INDEX_op_and32: {
    long param1, param2, param3;
    extern void op_and32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_and32+0), 46);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 29) = param1 - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_op) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 46;
}
break;

case INDEX_op_or32: {
    long param1, param2, param3;
    extern void op_or32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_or32+0), 46);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 29) = param1 - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_op) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 46;
}
break;

case INDEX_op_xor32: {
    long param1, param2, param3;
    extern void op_xor32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_xor32+0), 46);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 29) = param1 - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_op) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 46;
}
break;

case INDEX_op_shl32: {
    long param1, param2, param3;
    extern void op_shl32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_shl32+0), 48);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 31) = param1 - (long)(gen_code_ptr + 31) + -4;
    *(uint32_t *)(gen_code_ptr + 42) = (long)(&helper_set_op) - (long)(gen_code_ptr + 42) + -4;
    gen_code_ptr += 48;
}
break;

case INDEX_op_shl_cc: {
    long param1, param2;
    extern void op_shl_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_shl_cc+0), 100);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 7) = (uint32_t)param1 + 0;
    *(uint32_t *)(gen_code_ptr + 29) = (long)(&helper_get_op) - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 35) = param2 - (long)(gen_code_ptr + 35) + -4;
    *(uint32_t *)(gen_code_ptr + 43) = (long)(&helper_get_op) - (long)(gen_code_ptr + 43) + -4;
    *(uint32_t *)(gen_code_ptr + 64) = (long)(&helper_set_op) - (long)(gen_code_ptr + 64) + -4;
    gen_code_ptr += 100;
}
break;

case INDEX_op_shr32: {
    long param1, param2, param3;
    extern void op_shr32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_shr32+0), 48);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 31) = param1 - (long)(gen_code_ptr + 31) + -4;
    *(uint32_t *)(gen_code_ptr + 42) = (long)(&helper_set_op) - (long)(gen_code_ptr + 42) + -4;
    gen_code_ptr += 48;
}
break;

case INDEX_op_shr_cc: {
    long param1, param2;
    extern void op_shr_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_shr_cc+0), 100);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 7) = (uint32_t)param1 + 0;
    *(uint32_t *)(gen_code_ptr + 29) = (long)(&helper_get_op) - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 35) = param2 - (long)(gen_code_ptr + 35) + -4;
    *(uint32_t *)(gen_code_ptr + 43) = (long)(&helper_get_op) - (long)(gen_code_ptr + 43) + -4;
    *(uint32_t *)(gen_code_ptr + 64) = (long)(&helper_set_op) - (long)(gen_code_ptr + 64) + -4;
    gen_code_ptr += 100;
}
break;

case INDEX_op_sar_cc: {
    long param1, param2;
    extern void op_sar_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_sar_cc+0), 100);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 7) = (uint32_t)param1 + 0;
    *(uint32_t *)(gen_code_ptr + 29) = (long)(&helper_get_op) - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 35) = param2 - (long)(gen_code_ptr + 35) + -4;
    *(uint32_t *)(gen_code_ptr + 43) = (long)(&helper_get_op) - (long)(gen_code_ptr + 43) + -4;
    *(uint32_t *)(gen_code_ptr + 64) = (long)(&helper_set_op) - (long)(gen_code_ptr + 64) + -4;
    gen_code_ptr += 100;
}
break;

case INDEX_op_ext8u32: {
    long param1, param2;
    extern void op_ext8u32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ext8u32+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_ext8s32: {
    long param1, param2;
    extern void op_ext8s32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ext8s32+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_ext16u32: {
    long param1, param2;
    extern void op_ext16u32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ext16u32+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_ext16s32: {
    long param1, param2;
    extern void op_ext16s32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ext16s32+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_ld8u32: {
    long param1, param2;
    extern void op_ld8u32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld8u32+0), 27);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param1 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_set_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 27;
}
break;

case INDEX_op_ld8s32: {
    long param1, param2;
    extern void op_ld8s32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld8s32+0), 27);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param1 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_set_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 27;
}
break;

case INDEX_op_ld16u32: {
    long param1, param2;
    extern void op_ld16u32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld16u32+0), 36);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param1 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = (long)(&helper_set_op) - (long)(gen_code_ptr + 32) + -4;
    gen_code_ptr += 36;
}
break;

case INDEX_op_ld16s32: {
    long param1, param2;
    extern void op_ld16s32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld16s32+0), 40);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param1 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 36) = (long)(&helper_set_op) - (long)(gen_code_ptr + 36) + -4;
    gen_code_ptr += 40;
}
break;

case INDEX_op_ld32: {
    long param1, param2;
    extern void op_ld32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld32+0), 28);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 19) = param1 - (long)(gen_code_ptr + 19) + -4;
    *(uint32_t *)(gen_code_ptr + 24) = (long)(&helper_set_op) - (long)(gen_code_ptr + 24) + -4;
    gen_code_ptr += 28;
}
break;

case INDEX_op_st8: {
    long param1, param2;
    extern void op_st8();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_st8+0), 33);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param1 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param2 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 33;
}
break;

case INDEX_op_st16: {
    long param1, param2;
    extern void op_st16();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_st16+0), 43);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param1 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param2 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 43;
}
break;

case INDEX_op_st32: {
    long param1, param2;
    extern void op_st32();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_st32+0), 35);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param1 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param2 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 35;
}
break;

case INDEX_op_ldf64: {
    long param1, param2;
    extern void op_ldf64();
extern char helper_get_op;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_ldf64+0), 69);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 49) = param1 - (long)(gen_code_ptr + 49) + -4;
    *(uint32_t *)(gen_code_ptr + 63) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 63) + -4;
    gen_code_ptr += 69;
}
break;

case INDEX_op_stf64: {
    long param1, param2;
    extern void op_stf64();
extern char helper_get_op;
extern char helper_get_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_stf64+0), 49);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param1 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param2 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 49;
}
break;

case INDEX_op_flush_flags: {
    long param1;
    extern void op_flush_flags();
extern char cpu_m68k_flush_flags;
    memcpy(gen_code_ptr, (void *)((char *)&op_flush_flags+0), 29);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&cpu_m68k_flush_flags) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 29;
}
break;

case INDEX_op_divu: {
    long param1;
    extern void op_divu();
extern char cpu_loop_exit;
    memcpy(gen_code_ptr, (void *)((char *)&op_divu+0), 138);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 38) = (long)(&cpu_loop_exit) - (long)(gen_code_ptr + 38) + -4;
    *(uint32_t *)(gen_code_ptr + 61) = (uint32_t)param1 + 0;
    gen_code_ptr += 138;
}
break;

case INDEX_op_divs: {
    long param1;
    extern void op_divs();
extern char cpu_loop_exit;
    memcpy(gen_code_ptr, (void *)((char *)&op_divs+0), 136);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 44) = (long)(&cpu_loop_exit) - (long)(gen_code_ptr + 44) + -4;
    *(uint32_t *)(gen_code_ptr + 60) = (uint32_t)param1 + 0;
    gen_code_ptr += 136;
}
break;

case INDEX_op_raise_exception: {
    long param1;
    extern void op_raise_exception();
extern char cpu_loop_exit;
    memcpy(gen_code_ptr, (void *)((char *)&op_raise_exception+0), 24);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 5) = (uint32_t)param1 + 0;
    *(uint32_t *)(gen_code_ptr + 16) = (long)(&cpu_loop_exit) - (long)(gen_code_ptr + 16) + -4;
    gen_code_ptr += 24;
}
break;

case INDEX_op_sub_cmpf64: {
    long param1, param2, param3;
    extern void op_sub_cmpf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char helper_sub_cmpf64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_sub_cmpf64+0), 57);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 37) = (long)(&helper_sub_cmpf64) - (long)(gen_code_ptr + 37) + -4;
    *(uint32_t *)(gen_code_ptr + 43) = param1 - (long)(gen_code_ptr + 43) + -4;
    *(uint32_t *)(gen_code_ptr + 51) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 51) + -4;
    gen_code_ptr += 57;
}
break;

case INDEX_op_update_xflag_tst: {
    long param1;
    extern void op_update_xflag_tst();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_update_xflag_tst+0), 14);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 14;
}
break;

case INDEX_op_update_xflag_lt: {
    long param1, param2;
    extern void op_update_xflag_lt();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_update_xflag_lt+0), 41);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param1 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param2 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 41;
}
break;

case INDEX_op_get_xflag: {
    long param1;
    extern void op_get_xflag();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_get_xflag+0), 14);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 5) = param1 - (long)(gen_code_ptr + 5) + -4;
    *(uint32_t *)(gen_code_ptr + 10) = (long)(&helper_set_op) - (long)(gen_code_ptr + 10) + -4;
    gen_code_ptr += 14;
}
break;

case INDEX_op_logic_cc: {
    long param1;
    extern void op_logic_cc();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_logic_cc+0), 14);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 14;
}
break;

case INDEX_op_update_cc_add: {
    long param1, param2;
    extern void op_update_cc_add();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_update_cc_add+0), 36);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param1 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_op) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param2 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 36;
}
break;

case INDEX_op_fp_result: {
    long param1;
    extern void op_fp_result();
extern char helper_get_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_fp_result+0), 18);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 18;
}
break;

case INDEX_op_jmp: {
    long param1;
    extern void op_jmp();
    memcpy(gen_code_ptr, (void *)((char *)&op_jmp+0), 5);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 1) = gen_labels[param1] - (long)(gen_code_ptr + 1) + -4;
    gen_code_ptr += 5;
}
break;

case INDEX_op_jmp_z32: {
    long param1, param2;
    extern void op_jmp_z32();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_jmp_z32+0), 20);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 16) = gen_labels[param2] - (long)(gen_code_ptr + 16) + -4;
    gen_code_ptr += 20;
}
break;

case INDEX_op_jmp_nz32: {
    long param1, param2;
    extern void op_jmp_nz32();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_jmp_nz32+0), 20);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 16) = gen_labels[param2] - (long)(gen_code_ptr + 16) + -4;
    gen_code_ptr += 20;
}
break;

case INDEX_op_jmp_s32: {
    long param1, param2;
    extern void op_jmp_s32();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_jmp_s32+0), 20);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 16) = gen_labels[param2] - (long)(gen_code_ptr + 16) + -4;
    gen_code_ptr += 20;
}
break;

case INDEX_op_jmp_ns32: {
    long param1, param2;
    extern void op_jmp_ns32();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_jmp_ns32+0), 20);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 16) = gen_labels[param2] - (long)(gen_code_ptr + 16) + -4;
    gen_code_ptr += 20;
}
break;

case INDEX_op_goto_tb0: {
    long param1;
    extern void op_goto_tb0();
    memcpy(gen_code_ptr, (void *)((char *)&op_goto_tb0+0), 9);
    label_offsets[0] = 8 + (gen_code_ptr - gen_code_buf);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + 56;
    gen_code_ptr += 9;
}
break;

case INDEX_op_goto_tb1: {
    long param1;
    extern void op_goto_tb1();
    memcpy(gen_code_ptr, (void *)((char *)&op_goto_tb1+0), 9);
    label_offsets[1] = 8 + (gen_code_ptr - gen_code_buf);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + 60;
    gen_code_ptr += 9;
}
break;

case INDEX_op_exit_tb: {
    extern void op_exit_tb();
    memcpy(gen_code_ptr, (void *)((char *)&op_exit_tb+0), 1);
    gen_code_ptr += 1;
}
break;

case INDEX_op_f64_to_i32: {
    long param1, param2;
    extern void op_f64_to_i32();
extern char helper_get_opf64;
extern char float64_to_int32;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_f64_to_i32+0), 47);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_to_int32) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 39) = (long)(&helper_set_op) - (long)(gen_code_ptr + 39) + -4;
    gen_code_ptr += 47;
}
break;

case INDEX_op_f64_to_f32: {
    long param1, param2;
    extern void op_f64_to_f32();
extern char helper_get_opf64;
extern char float64_to_float32;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_f64_to_f32+0), 47);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_to_float32) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 39) = (long)(&helper_set_op) - (long)(gen_code_ptr + 39) + -4;
    gen_code_ptr += 47;
}
break;

case INDEX_op_i32_to_f64: {
    long param1, param2;
    extern void op_i32_to_f64();
extern char helper_get_op;
extern char int32_to_float64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_i32_to_f64+0), 47);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 25) = (long)(&int32_to_float64) - (long)(gen_code_ptr + 25) + -4;
    *(uint32_t *)(gen_code_ptr + 31) = param1 - (long)(gen_code_ptr + 31) + -4;
    *(uint32_t *)(gen_code_ptr + 39) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 39) + -4;
    gen_code_ptr += 47;
}
break;

case INDEX_op_f32_to_f64: {
    long param1, param2;
    extern void op_f32_to_f64();
extern char helper_get_op;
extern char float32_to_float64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_f32_to_f64+0), 47);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 25) = (long)(&float32_to_float64) - (long)(gen_code_ptr + 25) + -4;
    *(uint32_t *)(gen_code_ptr + 31) = param1 - (long)(gen_code_ptr + 31) + -4;
    *(uint32_t *)(gen_code_ptr + 39) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 39) + -4;
    gen_code_ptr += 47;
}
break;

case INDEX_op_absf64: {
    long param1, param2;
    extern void op_absf64();
extern char helper_get_opf64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_absf64+0), 38);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 34) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 34) + -4;
    gen_code_ptr += 38;
}
break;

case INDEX_op_chsf64: {
    long param1, param2;
    extern void op_chsf64();
extern char helper_get_opf64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_chsf64+0), 35);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 31) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 31) + -4;
    gen_code_ptr += 35;
}
break;

case INDEX_op_sqrtf64: {
    long param1, param2;
    extern void op_sqrtf64();
extern char helper_get_opf64;
extern char float64_sqrt;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_sqrtf64+0), 48);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_sqrt) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 48;
}
break;

case INDEX_op_addf64: {
    long param1, param2, param3;
    extern void op_addf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_add;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_addf64+0), 61);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 41) = (long)(&float64_add) - (long)(gen_code_ptr + 41) + -4;
    *(uint32_t *)(gen_code_ptr + 47) = param1 - (long)(gen_code_ptr + 47) + -4;
    *(uint32_t *)(gen_code_ptr + 55) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 55) + -4;
    gen_code_ptr += 61;
}
break;

case INDEX_op_subf64: {
    long param1, param2, param3;
    extern void op_subf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_sub;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_subf64+0), 61);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 41) = (long)(&float64_sub) - (long)(gen_code_ptr + 41) + -4;
    *(uint32_t *)(gen_code_ptr + 47) = param1 - (long)(gen_code_ptr + 47) + -4;
    *(uint32_t *)(gen_code_ptr + 55) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 55) + -4;
    gen_code_ptr += 61;
}
break;

case INDEX_op_mulf64: {
    long param1, param2, param3;
    extern void op_mulf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_mul;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_mulf64+0), 61);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 41) = (long)(&float64_mul) - (long)(gen_code_ptr + 41) + -4;
    *(uint32_t *)(gen_code_ptr + 47) = param1 - (long)(gen_code_ptr + 47) + -4;
    *(uint32_t *)(gen_code_ptr + 55) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 55) + -4;
    gen_code_ptr += 61;
}
break;

case INDEX_op_divf64: {
    long param1, param2, param3;
    extern void op_divf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_div;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_divf64+0), 61);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 41) = (long)(&float64_div) - (long)(gen_code_ptr + 41) + -4;
    *(uint32_t *)(gen_code_ptr + 47) = param1 - (long)(gen_code_ptr + 47) + -4;
    *(uint32_t *)(gen_code_ptr + 55) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 55) + -4;
    gen_code_ptr += 61;
}
break;

case INDEX_op_iround_f64: {
    long param1, param2;
    extern void op_iround_f64();
extern char helper_get_opf64;
extern char float64_round_to_int;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_iround_f64+0), 48);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_round_to_int) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 48;
}
break;

case INDEX_op_itrunc_f64: {
    long param1, param2;
    extern void op_itrunc_f64();
extern char helper_get_opf64;
extern char float64_trunc_to_int;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_itrunc_f64+0), 48);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_trunc_to_int) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 48;
}
break;

case INDEX_op_compare_quietf64: {
    long param1, param2, param3;
    extern void op_compare_quietf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_compare_quiet;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_compare_quietf64+0), 60);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 4) = param2 - (long)(gen_code_ptr + 4) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param3 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 23) + -4;
    *(uint32_t *)(gen_code_ptr + 41) = (long)(&float64_compare_quiet) - (long)(gen_code_ptr + 41) + -4;
    *(uint32_t *)(gen_code_ptr + 47) = param1 - (long)(gen_code_ptr + 47) + -4;
    *(uint32_t *)(gen_code_ptr + 54) = (long)(&helper_set_op) - (long)(gen_code_ptr + 54) + -4;
    gen_code_ptr += 60;
}
break;

        case INDEX_op_nop:
            break;
        case INDEX_op_nop1:
            opparam_ptr++;
            break;
        case INDEX_op_nop2:
            opparam_ptr += 2;
            break;
        case INDEX_op_nop3:
            opparam_ptr += 3;
            break;
        default:
            goto the_end;
        }
    }
 the_end:
flush_icache_range((unsigned long)gen_code_buf, (unsigned long)gen_code_ptr);
return gen_code_ptr -  gen_code_buf;
}

